﻿using System.Collections.Generic;
using System.IO;

namespace ClassLibrary1
{
    public class MyTable
    {
        private const int tdBeginCharsCount = 4;// '<td>' length
        private const int tdEndCharsCount = 5;// '</td>' length
        public IEnumerable<MyTableModel> GetMyTableData(string fileName)
        {
            var tableData = new List<MyTableModel>();
            using (var stream = new StreamReader(fileName))
            {
                string line;
                bool inTable = false;
                bool inTR= false;
                int columnIndex = 0;
                int rowIndex = 0;

                while ((line = stream.ReadLine()) != null)
                {
                    string trimmedLine = line.Trim().ToLower();
                    switch (trimmedLine)
                    {
                        case "<tr>":
                            {
                                inTR = true;
                                rowIndex += 1;
                                break;
                            }
                        case "</tr>":
                            {
                                inTR = false;
                                columnIndex = 0;
                                break;
                            }
                        case "<table>":
                            {
                                inTable = true;
                                break;
                            }
                        case "</table>":
                            {
                                inTable = false;
                                break;
                            }
                        default:
                            {
                                if (inTable && inTR)
                                {
                                    columnIndex += 1;
                                    MyTableModel item = new MyTableModel()
                                    {
                                        ColumnName = $"column{columnIndex}",
                                        RowIndex = rowIndex,
                                        CellContent = this.GetCellContent(trimmedLine)
                                    };

                                    tableData.Add(item);
                                }

                                break;
                            }
                    }
                }
            }

            return tableData;
        }

        private string GetCellContent(string line)
        {
            string cellContent = line.Remove(line.Length - tdEndCharsCount, tdEndCharsCount);
            cellContent = cellContent.Remove(0, tdBeginCharsCount);

            return cellContent;
        }
    }
}
